      SUBROUTINE PI0SIM
*.
*...PI0SIM   Generate kinematics for PI0 Decay
*.
*. SEQUENCE  : GCONST GCFLAG GCKINE XECINT XECGEO NTUPLE
*. CALLS     : RN3DIM LORENB
*. CALLED    : GUKINE
*.
*. BANKS L   : None
*. BANKS U   : None
*.
*. AUTHOR    : R.Sawada
*. VERSION   : 1.01
*. CREATED   : 12-Aug-03
*. LAST MOD  : 12-Aug-03
*.
*. Modification Log.
*. 12-Aug-03   R.Sawada       (V1.00) this program is base on 
*.                            S.Mihara's pi0sim.f
*.
*.**********************************************************************
*
#include "declare.inc"
#include "geant321/gconst.inc"
#include "geant321/gcflag.inc"
#include "geant321/gckine.inc"
#include "xecgeo.inc"
#include "xecint.inc"
#include "ntuple.inc"

      INTEGER I, J
      
      REAL PI0M, ABSPPI0
      PARAMETER (PI0M = 134.9766, ABSPPI0=28.04)
      
      REAL VABS
      REAL PPI0(4),PG1CM(4),PG2CM(4),PG1LB(4),PG2LB(4),ANGLE,ANGLAB
      COMMON/PI0DECAY/PPI0,PG1CM,PG2CM,PG1LB,PG2LB,ANGLE,ANGLAB
      
 10   CALL RN3DIM(PPI0(1), PPI0(2), PPI0(3) ,ABSPPI0)
      PPI0(4) = SQRT(ABSPPI0**2 + PI0M**2)
      
      CALL RN3DIM(PG1CM(1), PG1CM(2), PG1CM(3), PI0M/2.0)
      
      DO 20 J = 1, 3
         PG2CM(J) = -PG1CM(J)
 20   CONTINUE
      PG1CM(4) = PI0M/2.0
      PG2CM(4) = PI0M/2.0
      
      CALL LORENB(PI0M, PPI0, PG1CM, PG1LB)
      CALL LORENB(PI0M, PPI0, PG2CM, PG2LB)

      VABS = SQRT(PG1LB(1)*PG1LB(1)+PG1LB(2)*PG1LB(2)+PG1LB(3)*PG1LB(3))
      IF(ABS(PG1LB(3)/VABS) .LT. 1/2.) GOTO 10

      IF(PG1LB(3) .GT. 0.) THEN      
         PPIZ(1)= PG1LB(1)/1000.
         PPIZ(2)= PG1LB(2)/1000.
         PPIZ(3)= PG1LB(3)/1000.
         PPIZ(4)= PG2LB(1)/1000.
         PPIZ(5)= PG2LB(2)/1000.
         PPIZ(6)= PG2LB(3)/1000.
      ELSE 
         PPIZ(1)= PG2LB(1)/1000.
         PPIZ(2)= PG2LB(2)/1000.
         PPIZ(3)= PG2LB(3)/1000.
         PPIZ(4)= PG1LB(1)/1000.
         PPIZ(5)= PG1LB(2)/1000.
         PPIZ(6)= PG1LB(3)/1000.         
      END IF

      END
