      REAL FUNCTION QTRANS(WLEN)
*.
*...QTRANS   quartz transmittance for Xe scintillation light
*.
*. INPUT     : WLEN
*. RETURN    : quartz transmittance
*.
*. SEQUENCE  : XECSCI XECGEO
*. CALLS     : NONE
*. CALLED    : XSTRAK
*.
*. BANKS L   : None
*. BANKS U   : None
*.
*. AUTHOR    : K.Ozone
*. VERSION   : 1.00
*. CREATED   : 19-Aug-03
*. LAST MOD  : 19-Aug-03
*.
*. Modification Log.
*. 19-Aug-03 K.Ozone           (V1.00) Separated from xstrak.F.
*.
************************************************************************

#include "declare.inc"
#include "xecgeo.inc"
#include "xecsci.inc"

      REAL WLEN
*
      INTEGER IDX, IDXMIN, IDXMAX
      REAL WAVLEN(53), TRANS(53)
      DATA WAVLEN /             ! wavelength
     +     184.2169, 183.0120, 182.2892, 
     +     181.3253, 180.6024, 180.1205, 
     +     179.8795, 179.6386, 178.6747, 
     +     177.7108, 177.2289, 176.9880, 
     +     176.5060, 175.7831, 175.3012, 
     +     174.5783, 174.3373, 174.0964, 
     +     173.6145, 173.1325, 172.4096, 
     +     171.9277, 171.6867, 171.2048, 
     +     170.7229, 170.2410, 169.5181, 
     +     169.0361, 168.3133, 167.8313, 
     +     167.3494, 167.1084, 166.3855, 
     +     165.9036, 165.1807, 164.4578, 
     +     164.2169, 163.7349, 163.4940, 
     +     163.2530, 163.0120, 162.7711, 
     +     162.5301, 162.2892, 162.0482, 
     +     161.3253, 160.3614, 159.8795, 
     +     159.1566, 157.9518, 156.5060, 
     +     155.3012, 154.3373 /
      DATA TRANS /              ! transmittance against 2mmt quartz (by K.Terasawa)
     +     0.91422, 0.91301, 0.91229, 
     +     0.91133, 0.91060, 0.91012, 
     +     0.90976, 0.90928, 0.90702, 
     +     0.90384, 0.90192, 0.90095, 
     +     0.89902, 0.89592, 0.89351, 
     +     0.88989, 0.88869, 0.88748, 
     +     0.88430, 0.88093, 0.87410, 
     +     0.86928, 0.86687, 0.86205, 
     +     0.85723, 0.85241, 0.84374, 
     +     0.83747, 0.82533, 0.81325, 
     +     0.79398, 0.78434, 0.75542, 
     +     0.73344, 0.68429, 0.62429, 
     +     0.60309, 0.56067, 0.53947, 
     +     0.51826, 0.49706, 0.47586, 
     +     0.45465, 0.43345, 0.41224, 
     +     0.34863, 0.26380, 0.22212, 
     +     0.16284, 0.06759, 0.01259, 
     +     0.00220, 0.00034 /
      SAVE WAVLEN, TRANS
*
 100  CONTINUE
      IF( IDXMIN .GT. IDXMAX ) GOTO 150
      IDX = (IDXMIN + IDXMAX)/2
         
      IF( WAVLEN(IDX-1) .LT. WLEN ) THEN
         IF( WLEN .LE. WAVLEN(IDX) ) THEN
            GOTO 150
         ENDIF
      ENDIF
      IF( WLEN .LE. WAVLEN(IDX-1) ) THEN
         IDXMAX = IDX-1
      ELSE IF( WAVLEN(IDX) .LT. WLEN ) THEN
         IDXMIN = IDX+1
      ENDIF
      GO TO 100
*
 150  CONTINUE

      IF(IDX .EQ. 1) THEN
         QTRANS = WAVLEN(1) -
     +        (WAVLEN(1)-WLEN)/(WAVLEN(2)-WAVLEN(1))*
     +        (WAVLEN(2)-WAVLEN(1))
      ELSE
         QTRANS = WAVLEN(IDX) -
     +        (WAVLEN(IDX)-WLEN)/(WAVLEN(IDX) - WAVLEN(IDX-1))*
     +        (WAVLEN(IDX)-WAVLEN(IDX-1))
      END IF
*
      RETURN
      END
