      SUBROUTINE XSREFIDX(WLEN)
*.
*...XSREFIDX Calculate effective index of refraction in LXe
*.
*. INPUT     : wlen  Wave length (nm)
*. RETURN    :       effective index of refraction
*.
*. SEQUENCE  : XECSCI XECGEO
*. CALLS     : NONE
*. CALLED    : XSTRAK
*.
*. BANKS L   : None
*. BANKS U   : None
*.
*. AUTHOR    : S.Yamada
*. VERSION   : 1.01
*. CREATED   : 13-Aug-03
*. LAST MOD  : 19-Aug-03
*.
*. Modification Log.
*. 19-Aug-03 K.Ozone           (V1.01) Changed XDISPON to XENDST.
*.                             Changed FUNCTION to SUBROUTINE.
*. 13-Aug-03 S.Yamada          (V1.00) based on R.Sawada's XSTRAK.F in
*.                             lproto_0.08_rs version.
*.
************************************************************************

#include "declare.inc"
#include "xecgeo.inc"
#include "xecsci.inc"

      REAL WLEN
*
      REAL AOMEGA

      IF( XENDST .EQ. 1 ) THEN
         AOMEGA = 0.0227 * (EXP(0.1072/(WLEN - 146.6) + 6.847) - 928.5)
         RFRIDX = SQRT((1.0 + 2.0*AOMEGA) / (1.0 - AOMEGA))
      ENDIF

      RETURN
      END
